SynthSpinnerUI (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.swing.plaf.synth, class: SynthSpinnerUI
Keywords: javax.swing.plaf.synth.SynthSpinnerUI class

# Class SynthSpinnerUI

java.lang.Object
javax.swing.plaf.ComponentUI
javax.swing.plaf.SpinnerUI
javax.swing.plaf.basic.BasicSpinnerUI
javax.swing.plaf.synth.SynthSpinnerUI

All Implemented Interfaces:
  `PropertyChangeListener, EventListener, SynthConstants, SynthUI`

public class SynthSpinnerUI extends BasicSpinnerUI implements PropertyChangeListener, SynthUI
Provides the Synth L&F UI delegate for `JSpinner`.

Since:
  1.7

- ## Field Summary

  ### Fields declared in class BasicSpinnerUI

  `spinner`
  Modifier and Type
  Field
  Description
  `protected JSpinner`
  `spinner`
  The spinner that we're a UI delegate for.

  ### Fields declared in interface SynthConstants

  `DEFAULT, DISABLED, ENABLED, FOCUSED, MOUSE_OVER, PRESSED, SELECTED`
  Modifier and Type
  Field
  Description
  `static final int`
  `DEFAULT`
  Indicates the region is the default.
  `static final int`
  `DISABLED`
  Primary state indicating the region is not enabled.
  `static final int`
  `ENABLED`
  Primary state indicating the component is enabled.
  `static final int`
  `FOCUSED`
  Indicates the region has focus.
  `static final int`
  `MOUSE_OVER`
  Primary state indicating the mouse is over the region.
  `static final int`
  `PRESSED`
  Primary state indicating the region is in a pressed state.
  `static final int`
  `SELECTED`
  Indicates the region is selected.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SynthSpinnerUI()`
  Constructs a `SynthSpinnerUI`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected JComponent`
  `createEditor()`
  This method is called by installUI to get the editor component of the `JSpinner`.
  `static ComponentUI`
  `createUI(JComponent c)`
  Returns a new instance of SynthSpinnerUI.
  `SynthContext`
  `getContext(JComponent c)`
  Returns the Context for the specified component.
  `protected void`
  `installDefaults()`
  Initializes the `JSpinner` `border`, `foreground`, and `background`, properties based on the corresponding "Spinner.*" properties from defaults table.
  `void`
  `paint(Graphics g, JComponent c)`
  Paints the specified component according to the Look and Feel.
  `protected void`
  `paint(SynthContext context, Graphics g)`
  Paints the specified component.
  `void`
  `paintBorder(SynthContext context, Graphics g, int x, int y, int w, int h)`
  Paints the border.
  `void`
  `propertyChange(PropertyChangeEvent e)`
  This method gets called when a bound property is changed.
  `protected void`
  `replaceEditor(JComponent oldEditor, JComponent newEditor)`
  Called by the `PropertyChangeListener` when the `JSpinner` editor property changes.
  `protected void`
  `uninstallDefaults()`
  Sets the `JSpinner's` layout manager to null.
  `void`
  `update(Graphics g, JComponent c)`
  Notifies this UI delegate to repaint the specified component.

  ### Methods declared in class BasicSpinnerUI

  `createLayout, createNextButton, createPreviousButton, createPropertyChangeListener, getBaseline, getBaselineResizeBehavior, installKeyboardActions, installListeners, installNextButtonListeners, installPreviousButtonListeners, installUI, uninstallListeners, uninstallUI`
  Modifier and Type
  Method
  Description
  `protected LayoutManager`
  `createLayout()`
  Creates a `LayoutManager` that manages the `editor`, `nextButton`, and `previousButton` children of the JSpinner.
  `protected Component`
  `createNextButton()`
  Creates an increment button, i.e. component that replaces the spinner value with the object returned by `spinner.getNextValue`.
  `protected Component`
  `createPreviousButton()`
  Creates a decrement button, i.e. component that replaces the spinner value with the object returned by `spinner.getPreviousValue`.
  `protected PropertyChangeListener`
  `createPropertyChangeListener()`
  Creates a `PropertyChangeListener` that can be added to the JSpinner itself.
  `int`
  `getBaseline(JComponent c, int width, int height)`
  Returns the baseline.
  `Component.BaselineResizeBehavior`
  `getBaselineResizeBehavior(JComponent c)`
  Returns an enum indicating how the baseline of the component changes as the size changes.
  `protected void`
  `installKeyboardActions()`
  Installs the keyboard Actions onto the JSpinner.
  `protected void`
  `installListeners()`
  Initializes `PropertyChangeListener` with a shared object that delegates interesting PropertyChangeEvents to protected methods.
  `protected void`
  `installNextButtonListeners(Component c)`
  Installs the necessary listeners on the next button, `c`, to update the `JSpinner` in response to a user gesture.
  `protected void`
  `installPreviousButtonListeners(Component c)`
  Installs the necessary listeners on the previous button, `c`, to update the `JSpinner` in response to a user gesture.
  `void`
  `installUI(JComponent c)`
  Calls `installDefaults`, `installListeners`, and then adds the components returned by `createNextButton`, `createPreviousButton`, and `createEditor`.
  `protected void`
  `uninstallListeners()`
  Removes the `PropertyChangeListener` added by installListeners.
  `void`
  `uninstallUI(JComponent c)`
  Calls `uninstallDefaults`, `uninstallListeners`, and then removes all of the spinners children.

  ### Methods declared in class ComponentUI

  `contains, getAccessibleChild, getAccessibleChildrenCount, getMaximumSize, getMinimumSize, getPreferredSize`
  Modifier and Type
  Method
  Description
  `boolean`
  `contains(JComponent c, int x, int y)`
  Returns `true` if the specified x,y location is contained within the look and feel's defined shape of the specified component.
  `Accessible`
  `getAccessibleChild(JComponent c, int i)`
  Returns the `i`th `Accessible` child of the object.
  `int`
  `getAccessibleChildrenCount(JComponent c)`
  Returns the number of accessible children in the object.
  `Dimension`
  `getMaximumSize(JComponent c)`
  Returns the specified component's maximum size appropriate for the look and feel.
  `Dimension`
  `getMinimumSize(JComponent c)`
  Returns the specified component's minimum size appropriate for the look and feel.
  `Dimension`
  `getPreferredSize(JComponent c)`
  Returns the specified component's preferred size appropriate for the look and feel.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### SynthSpinnerUI

    public SynthSpinnerUI()
    Constructs a `SynthSpinnerUI`.

- ## Method Details

  - ### createUI

    public static ComponentUI createUI(JComponent c)
    Returns a new instance of SynthSpinnerUI.
    Parameters:
      `c` - the JSpinner (not used)
    Returns:
      a new SynthSpinnerUI object
    See Also:
      - `ComponentUI.createUI(JComponent)`

  - ### installDefaults

    protected void installDefaults()
    Initializes the `JSpinner` `border`, `foreground`, and `background`, properties based on the corresponding "Spinner.*" properties from defaults table. The `JSpinners` layout is set to the value returned by `createLayout`. This method is called by `installUI`.
    Overrides:
      `installDefaults` in class `BasicSpinnerUI`
    See Also:
      - `uninstallDefaults()`
      - `BasicSpinnerUI.installUI(JComponent)`
      - `BasicSpinnerUI.createLayout()`
      - `LookAndFeel.installBorder(JComponent, String)`
      - `LookAndFeel.installColors(JComponent, String, String)`

  - ### uninstallDefaults

    protected void uninstallDefaults()
    Sets the `JSpinner's` layout manager to null. This method is called by `uninstallUI`.
    Overrides:
      `uninstallDefaults` in class `BasicSpinnerUI`
    See Also:
      - `installDefaults()`
      - `BasicSpinnerUI.uninstallUI(JComponent)`

  - ### createEditor

    protected JComponent createEditor()
    This method is called by installUI to get the editor component of the `JSpinner`. By default it just returns `JSpinner.getEditor()`. Subclasses can override `createEditor` to return a component that contains the spinner's editor or null, if they're going to handle adding the editor to the `JSpinner` in an `installUI` override.

    Typically this method would be overridden to wrap the editor with a container with a custom border, since one can't assume that the editors border can be set directly.

    The `replaceEditor` method is called when the spinners editor is changed with `JSpinner.setEditor`. If you've overridden this method, then you'll probably want to override `replaceEditor` as well.

    Overrides:
      `createEditor` in class `BasicSpinnerUI`
    Returns:
      the JSpinners editor JComponent, spinner.getEditor() by default
    See Also:
      - `BasicSpinnerUI.installUI(JComponent)`
      - `replaceEditor(JComponent, JComponent)`
      - `JSpinner.getEditor()`

  - ### replaceEditor

    protected void replaceEditor(JComponent oldEditor, JComponent newEditor)
    Called by the `PropertyChangeListener` when the `JSpinner` editor property changes. It's the responsibility of this method to remove the old editor and add the new one. By default this operation is just:

        spinner.remove(oldEditor);
        spinner.add(newEditor, "Editor");

    The implementation of `replaceEditor` should be coordinated with the `createEditor` method.
    Overrides:
      `replaceEditor` in class `BasicSpinnerUI`
    Parameters:
      `oldEditor` - an old instance of editor
      `newEditor` - a new instance of editor
    See Also:
      - `createEditor()`
      - `BasicSpinnerUI.createPropertyChangeListener()`

  - ### getContext

    public SynthContext getContext(JComponent c)
    Returns the Context for the specified component.
    Specified by:
      `getContext` in interface `SynthUI`
    Parameters:
      `c` - Component requesting SynthContext.
    Returns:
      SynthContext describing component.

  - ### update

    public void update(Graphics g, JComponent c)
    Notifies this UI delegate to repaint the specified component. This method paints the component background, then calls the `paint(SynthContext,Graphics)` method.

    In general, this method does not need to be overridden by subclasses. All Look and Feel rendering code should reside in the `paint` method.

    Overrides:
      `update` in class `ComponentUI`
    Parameters:
      `g` - the `Graphics` object used for painting
      `c` - the component being painted
    See Also:
      - `paint(SynthContext,Graphics)`

  - ### paint

    public void paint(Graphics g, JComponent c)
    Paints the specified component according to the Look and Feel.

    This method is not used by Synth Look and Feel. Painting is handled by the `paint(SynthContext,Graphics)` method.

    Overrides:
      `paint` in class `ComponentUI`
    Parameters:
      `g` - the `Graphics` object used for painting
      `c` - the component being painted
    See Also:
      - `paint(SynthContext,Graphics)`

  - ### paint

    protected void paint(SynthContext context, Graphics g)
    Paints the specified component. This implementation does nothing.
    Parameters:
      `context` - context for the component being painted
      `g` - the `Graphics` object used for painting
    See Also:
      - `update(Graphics,JComponent)`

  - ### paintBorder

    public void paintBorder(SynthContext context, Graphics g, int x, int y, int w, int h)
    Paints the border.
    Specified by:
      `paintBorder` in interface `SynthUI`
    Parameters:
      `context` - a component context
      `g` - `Graphics` to paint on
      `x` - the X coordinate
      `y` - the Y coordinate
      `w` - width of the border
      `h` - height of the border

  - ### propertyChange

    public void propertyChange(PropertyChangeEvent e)
    This method gets called when a bound property is changed.
    Specified by:
      `propertyChange` in interface `PropertyChangeListener`
    Parameters:
      `e` - A PropertyChangeEvent object describing the event source and the property that has changed.